'use strict';

var _regeneratorRuntime = require('babel-runtime/regenerator').default;

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default').default;

exports.__esModule = true;

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _through2 = require('through2');

var _through22 = _interopRequireDefault(_through2);

var _promise = require('promise');

var _promise2 = _interopRequireDefault(_promise);

var _qunitHarness = require('qunit-harness');

var _qunitHarness2 = _interopRequireDefault(_qunitHarness);

var readFile = _promise2.default.denodeify(_fs2.default.readFile);

function hang() {
    return new _promise2.default(function () {
        // NOTE: hang forever
    });
}

function fillResource(src, path) {
    var content;
    return _regeneratorRuntime.async(function fillResource$(context$1$0) {
        while (1) switch (context$1$0.prev = context$1$0.next) {
            case 0:
                context$1$0.next = 2;
                return _regeneratorRuntime.awrap(readFile(path, 'utf-8'));

            case 2:
                content = context$1$0.sent;
                return context$1$0.abrupt('return', { src: src, content: content });

            case 4:
            case 'end':
                return context$1$0.stop();
        }
    }, null, this);
}

exports.default = function (options) {
    options = {
        basePath: options.basePath || '',
        scripts: options.scripts || [],
        css: options.css || [],
        configApp: options.configApp || null,
        saucelabsSettings: options.saucelabsSettings || null
    };

    var tests = [];
    var qunitHarness = new _qunitHarness2.default();

    function runTests() {
        var scripts, css;
        return _regeneratorRuntime.async(function runTests$(context$2$0) {
            while (1) switch (context$2$0.prev = context$2$0.next) {
                case 0:
                    context$2$0.next = 2;
                    return _regeneratorRuntime.awrap(_promise2.default.all(options.scripts.map(function (item) {
                        return fillResource(item.src, item.path);
                    })));

                case 2:
                    scripts = context$2$0.sent;
                    context$2$0.next = 5;
                    return _regeneratorRuntime.awrap(_promise2.default.all(options.css.map(function (item) {
                        return fillResource(item.src, item.path);
                    })));

                case 5:
                    css = context$2$0.sent;

                    qunitHarness.fixtures(options.basePath).scripts(scripts).css(css).tests(tests);

                    if (typeof options.configApp === 'function') qunitHarness.configApp(options.configApp);

                    qunitHarness.create();

                    if (!options.saucelabsSettings) {
                        context$2$0.next = 14;
                        break;
                    }

                    qunitHarness.saucelabs(options.saucelabsSettings);
                    context$2$0.next = 13;
                    return _regeneratorRuntime.awrap(qunitHarness.run());

                case 13:
                    return context$2$0.abrupt('return', context$2$0.sent);

                case 14:
                    context$2$0.next = 16;
                    return _regeneratorRuntime.awrap(hang());

                case 16:
                case 'end':
                    return context$2$0.stop();
            }
        }, null, this);
    }

    return _through22.default.obj(function (file, enc, done) {
        tests.push(file.path);
        done();
    }, function callee$1$0(done) {
        var error;
        return _regeneratorRuntime.async(function callee$1$0$(context$2$0) {
            while (1) switch (context$2$0.prev = context$2$0.next) {
                case 0:
                    error = null;
                    context$2$0.prev = 1;
                    context$2$0.next = 4;
                    return _regeneratorRuntime.awrap(runTests());

                case 4:
                    context$2$0.next = 9;
                    break;

                case 6:
                    context$2$0.prev = 6;
                    context$2$0.t0 = context$2$0['catch'](1);

                    error = context$2$0.t0;

                case 9:
                    context$2$0.prev = 9;

                    qunitHarness.close();
                    done(error);
                    return context$2$0.finish(9);

                case 13:
                case 'end':
                    return context$2$0.stop();
            }
        }, null, this, [[1, 6, 9, 13]]);
    });
};

;
module.exports = exports.default;